﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XMousePositionToDateTime
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = ChartData.GenerateData(10);
        }


        private void xamDataChart1_MouseMove(object sender, MouseEventArgs e)
        {
            double xPosition = e.GetPosition(xamDataChart1).X;

            ScalerParams sParams = new ScalerParams(xamDataChart1.WindowRect, xamDataChart1.ViewportRect, false);

            CategoryXAxis category = xAxis1;
            //Getting the index corresponding to the X coordinate
            int index = (int)category.GetUnscaledValue(xPosition, sParams);
            //Getting the item of the ItemsSource of the axis
            var item = category.ItemsSource.Cast<ChartData>().ElementAt(index);
            //Getting the DateTime Value
            catX.Content = item.Date;


            CategoryDateTimeXAxis dateTimeAxis = xAxis;
            //Getting the index corresponding to the X coordinate
            double ticks = dateTimeAxis.GetUnscaledValue(xPosition, sParams);
            //Converting the double to DateTime 
            DateTime dt = new DateTime((long)ticks);
            catDate.Content = dt;
        }
    }

        
    public class ChartData
    {
        public DateTime Date { get; set; }
        public int Index { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
        public double Value3 { get; set; }

        public static ObservableCollection<ChartData> GenerateData(int count)
        {
            ObservableCollection<ChartData> data = new ObservableCollection<ChartData>();

            Random r = new Random();

            ChartData data0 = new ChartData
            {
                Date = DateTime.Now,
                Index = 0,
                Value1 = r.Next(20, 40),
                Value2 = r.Next(20, 40),
                Value3 = r.Next(20, 40),
            };

            data.Add(data0);

            for (int i = 1; i < count; i++)
            {
                ChartData dat = new ChartData
                {
                    Date = DateTime.Now.AddDays(i),
                    Index = i,
                };

                if (r.NextDouble() > .5)
                {
                    dat.Value1 = data[i - 1].Value1 + r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 + r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 + r.NextDouble();
                }
                else
                {
                    dat.Value1 = data[i - 1].Value1 - r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 - r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 - r.NextDouble();
                }

                data.Add(dat);
            }

            return data;
        }
    }
				
}
